#include <iostream>
#include <string>
#include <memory>
#include <stdlib.h>
#include <dlfcn.h>
#include "libmy.h"

class Opener {
  public:
    Opener(std::string filename);
    ~Opener();
    void *getHandle();
  private:
    void *handle;
};

Opener::Opener(std::string filename)
{
  if((handle = dlopen(filename.c_str(), RTLD_LAZY)) == NULL) {
    std::cout << "error opening library" << dlerror() << "\n";
    exit(1);
  }
}

Opener::~Opener()
{
  dlclose(handle);
}

void *Opener::getHandle()
{
  return handle;
}

int main()
{
  std::cerr << "You are in the begining of main\n";

  // opens the dynamic library
  Opener dynLibrary("./libmy.so");

  typedef std::auto_ptr<Myclass> Myclass_ptr;
  typedef Myclass_ptr (*libFunc_t)();

  libFunc_t libFunc;

  // Opens function libFunc from the dynamic library
  if ((libFunc = (libFunc_t) dlsym(dynLibrary.getHandle(), "libFunc")) == 0) {
    std::cerr << "Cannot load symbol \"libFunc\": " << dlerror() << "\n";
    return 1;
  }

  // calls dynamic function
  Myclass_ptr x = libFunc();

  // Calls the member function doStuff
  x->doStuff();

  std::cerr << "You are in the end of main\n";

  return 0;
}
